/**********************************************************************

** set_attr_to_component.cpp

22  2006  

   -  (..  "RIVET"  .
    ,   .

1.	   -,   
	.      <UF_UI_select_with_class_dialog>
	      <component_init_proc>
	    <rivet_attr>  
	    <rivet>.

*********************************************************/
/* Include files */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>


#include <uf.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_exit.h>
#include <uf_disp.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>
#include <uf_attr.h>




#define FREE_OBJ(object)\
	if(object)\
		for(i=0;i<count;i++)\
		{\
			errorCode=UF_DISP_set_highlight(object[i],0);\
			PRTERR(__LINE__);\
		}\
	UF_free(object);


extern	FILE*		prterr;
extern	int			errorCode;

extern	char	*atr_rivet;			    
extern	char	*atr_pr_code;			
extern	char	*atr_ad_code;			
extern	char	*atr_fast_code;			
extern	char	*atr_grip_lng;			

int	component_init_proc(UF_UI_selection_p_t select, void* user_data);

#define PRTERR(line)if(errorCode)\
			{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}

//******************************************************************
static	void	PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d		message=%s		line=%d\n",
			errorCode,message,line);
		fflush(prterr);
	}
}
//******************************************************************
static int rivet_attr(	tag_t object,
						int type[3],
						void *user_data,
						UF_UI_selection_p_t select)
{//     "rivet"

	int					indx,
						attr_type=UF_ATTR_string;
	
	char				title[100];

	UF_ATTR_value_t		value;

	static char			rivet_type[300];

	value.value.string=rivet_type;

	indx=0;
	errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
	PRTERR(__LINE__);
	
	while(indx)
	{
		if(strcmp(title,"RIVET")==0)
			return UF_UI_SEL_ACCEPT;
		errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
		PRTERR(__LINE__);
	}


term:
	return UF_UI_SEL_REJECT;
}
//******************************************************************
int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	
		sel_code,
		ret_code,
		num_triples=1;
	UF_UI_mask_t	
		mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	sel_code= UF_UI_set_sel_procs(select,rivet_attr,NULL,user_data);

	if( (ret_code==0) && (sel_code==0) )
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}


//******************************************************************
int	set_attr_to_comp(void)
{/*	 
	 ,     "RIVET".
	   !!!!!!!!!.

	   (  ) :	rivet,
																		pr_code, 
																		ad_code, 
																		fast_code, 
																		grip_lng
	   ,   . 
	


	e scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,     
	..       
 */
	int			rivet_count;
	tag_t		rivet_array[30000];


label_select:
	{//  ,   .

		tag_p_t			object;
		int				i,response,		
						scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,
			        	count;
		char*		message="   - ";
		char*		title="  - ";
		void*		user_data=NULL;

		errorCode=UF_UI_select_with_class_dialog
			(message, title, scope, component_init_proc, NULL, &response, &count, &object);
		PRTERR(__LINE__);
	
		switch(response)
		{	
			case UF_UI_BACK:
				FREE_OBJ(object);
				fprintf(prterr,"\n  BACK\n");
				goto label_select;
		
			case UF_UI_CANCEL:
				FREE_OBJ(object);
				fprintf(prterr,"\n  CANCEL\n");
				goto term;
		}

		fprintf( prterr,"\n  = %d", count );

		
		if(count<=0)
		{//  
			uc1601("  ",1);
			FREE_OBJ(object);
			goto label_select;
		}

		//   
		for(i=0;i<count;i++)
				rivet_array[i]=object[i];

		rivet_count=count;

		//    
		FREE_OBJ(object);

	}//		-	  



	

//  ( pr_code, ad_code, fast_code, grip_lng) 
//  .
	
	{// 0 -    "rivet"    

		char*	title="rivet";
		char*	znach=atr_rivet;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		fprintf(prterr,"\n rivet  %d ", i);
	
	}// 0
	

	
	
	{// 1 -    "pr_code"    

		char*	title="pr_code";
		char*	znach=atr_pr_code;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		fprintf(prterr,"\n pr_code  %d ", i);
	
	}// 1 
	

	{// 2  -    "ad_code"    

		char*	title="ad_code";
		char*	znach=atr_ad_code;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		fprintf(prterr,"\n ad_code  %d ", i);
	
	}// 2


	{// 3  -    "fast_code"    

		char*	title="fast_code";
		char*	znach=atr_fast_code;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		fprintf(prterr,"\n fast_code  %d ", i);
	
	}// 3


	{// 4  -    "grip_lng"    

		char*	title="grip_lng";
		char*	znach=atr_grip_lng;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		fprintf(prterr,"\n grip_lng  %d ", i);
	
	}// 4




term:
	;
fprintf(prterr,"\nset_attr_to_component - \n");

return 0;
}


